/// <reference path="../../headers/common.d.ts" />
System.register(["app/plugins/sdk", "moment", "jquery"], function (exports_1, context_1) {
    "use strict";
    var __extends = (this && this.__extends) || (function () {
        var extendStatics = function (d, b) {
            extendStatics = Object.setPrototypeOf ||
                ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
                function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
            return extendStatics(d, b);
        };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var sdk_1, moment_1, jquery_1, PanelCtrl;
    var __moduleName = context_1 && context_1.id;
    return {
        setters: [
            function (sdk_1_1) {
                sdk_1 = sdk_1_1;
            },
            function (moment_1_1) {
                moment_1 = moment_1_1;
            },
            function (jquery_1_1) {
                jquery_1 = jquery_1_1;
            }
        ],
        execute: function () {/// <reference path="../../headers/common.d.ts" />
            PanelCtrl = /** @class */ (function (_super) {
                __extends(PanelCtrl, _super);
                function PanelCtrl($scope, $injector, $http) {
                    var _this = _super.call(this, $scope, $injector) || this;
                    _this.$scope = $scope;
                    _this.$injector = $injector;
                    _this.$http = $http;
                    // Re-init all scope params
                    _this.reset($scope);
                    $scope.checkForUpdate = _this.checkForUpdate.bind(_this, $scope, $http);
                    $scope.getCurrentVersion = _this.getCurrentVersion.bind(_this, $scope, $http);
                    $scope.getCurrentVersion($scope, $http);
                    $scope.checkForUpdate($scope, $http);
                    return _this;
                }
                /**
                 * Send request to check if update possible and re-init params
                 */
                PanelCtrl.prototype.checkForUpdate = function ($scope, $http) {
                    var refreshButton = jquery_1.default('#refresh');
                    refreshButton.addClass('fa-spin');
                    $scope.isChecked = false;
                    $http({
                        method: 'GET',
                        url: PanelCtrl.API.CHECK_FOR_UPDATE,
                    }).then(function (res) {
                        $scope.latestVersion = res.data.version || '';
                        $scope.latestReleaseDate = res.data.release_date ? (new Date(res.data.release_date)).toLocaleString('en-US', PanelCtrl.RELEASE_DATE_OPTION) : '';
                        $scope.updateNeeded = res.data.update_needed || false;
                        $scope.lastCheckDate = moment_1.default(Number(Date.now().toString())).locale('en').format('MMMM DD, H:mm');
                    }).catch(function () {
                        $scope.latestVersion = '';
                        $scope.latestReleaseDate = '';
                    }).finally(function () {
                        $scope.isChecked = true;
                    });
                    refreshButton.removeClass('fa-spin');
                };
                /**
                 * Send request to get current version
                 */
                PanelCtrl.prototype.getCurrentVersion = function ($scope, $http) {
                    $http({
                        method: 'GET',
                        url: PanelCtrl.API.GET_CURRENT_VERSION,
                    }).then(function (res) {
                        $scope.currentVersion = res.data.version;
                        $scope.currentReleaseDate = res.data.release_date ? (new Date(res.data.release_date)).toLocaleString('en-US', PanelCtrl.RELEASE_DATE_OPTION) : '';
                        jquery_1.default('#refresh').removeClass('fa-spin');
                    }).catch(function () {
                        jquery_1.default('#refresh').removeClass('fa-spin');
                        //TODO: add error handler
                    });
                };
                /**
                 * Re-init all inner parameters that can be changed during update
                 */
                PanelCtrl.prototype.reset = function ($scope) {
                    $scope.isChecked = false;
                };
                /**
                 * Urls to define panels templates
                 */
                PanelCtrl.TEMPLATES = {
                    MAIN: 'index.html',
                };
                /**
                 * Urls to define API endpoints
                 */
                PanelCtrl.API = {
                    GET_CURRENT_VERSION: '/configurator/v1/version',
                    CHECK_FOR_UPDATE: '/configurator/v1/check-update',
                };
                /**
                 * Date format otpions
                 */
                PanelCtrl.RELEASE_DATE_OPTION = {
                    year: 'numeric',
                    month: 'long',
                    day: 'numeric'
                };
                /**
                 * Grafana param, define url of template that will be used for panel
                 */
                PanelCtrl.templateUrl = PanelCtrl.TEMPLATES.MAIN;
                return PanelCtrl;
            }(sdk_1.MetricsPanelCtrl));
            exports_1("PanelCtrl", PanelCtrl);
        }
    };
});
//# sourceMappingURL=module.js.map